from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from Products.CMFCore.PortalContent import PortalContent

from config import product_name, plone_product_name
from config import add_permission, edit_permission, view_permission


factory_type_information = {
  'id': plone_product_name,
  'meta_type': product_name,
  'description': ('Stores connection information for remote systems.'),
  'product': product_name,
  'factory': 'addManagedSystem',
  'content_icon': 'system_link.gif',
  'immediate_view': 'view',
  'actions': (
             {'id': 'view',
              'name': 'Display Address',
              'action': 'managedsystem_view_form',
              'permissions': (view_permission,)},
              {'id': 'edit',
               'name': 'Modify Address',
               'action': 'managedsystem_edit_form',
               'permissions': (edit_permission,)},
               ),
  }

class ManagedSystem(PortalContent, DefaultDublinCoreImpl):
  meta_type = product_name
  __implements__ = (
    PortalContent.__implements__,
    DefaultDublinCoreImpl.__implements__
    )

  security = ClassSecurityInfo()

  def __init__(self, id):
    self.id = id
    self.address = ""

  security.declareProtected(view_permission, "getAddress")
  def getAddress(self):
    return self.address

  security.declareProtected(edit_permission, "edit")
  def edit(self, addr):
    self.address = addr

  security.declareProtected(view_permission, "SearchableText")
  def SearchableText(self):
    """ Used by the catalog for basic full text indexing """
    return "%s %s %s" % ( self.Title()
                        , self.Description()
                        , self.address
                        )


def addManagedSystem(self, id, REQUEST=None):
  """This factory function creates a new ManagedSystem object"""
  obj = ManagedSystem(id)
  self._setObject(id, obj)

InitializeClass(ManagedSystem)
