# Copyright (C) 2004-2005 struktur AG and Contributors <simon@struktur.de>
# http://www.strukturag.com, http://www.icoya.com

# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL). A copy of the ZPL should accompany this distribution.

# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.

# See LICENSE.txt for details

""" Session Crumbler: enable session for non session user folders.

$Id: SessionCrumbler.py 11520 2005-08-30 15:25:54Z longsleep $
"""

from ZPublisher.BeforeTraverse import queryBeforeTraverse

def hasSession(context):
    # check if there is a session attached to the current browser

    # get root session data manager
    sdm = getRootSessionDataManager(context)
    if sdm is None: return False

    # check for session data in manager without creating a new one
    return sdm.getSessionData(create=0) and True or False

# define a alias for the main method
sessionlazycheck=hasSession

def getRootSessionDataManager(context):
    # return the sessiondatamanager from zope root

    # get physicalroot
    app = context.getPhysicalRoot()
    
    # get handlers for SessionDataManager
    handlers = queryBeforeTraverse(app, 'SessionDataManager')
    if not len(handlers): return None
    
    # get sessiondatamanagertraverser
    sdmt = handlers[0][1]
        
    # get name of data manager
    name = sdmt._sessionDataManager
    
    # get sessiondatamanager by name
    return getattr(app, name)

